#include "ImageIO.h"

ImageIO::ImageIO() {}

ImageIO::~ImageIO() {}

unsigned short ImageIO::swap16(unsigned char *pt) {
	unsigned short ret;
	ret  = *pt;
	ret |= (*(pt+1)<<8)&0xff00;
	return ret;
}

unsigned long ImageIO::swap32(uint8_t *pt) {
	uint32_t ret;
	ret  = *pt;
	ret |= (*(pt+1)<< 8)&0x0000ff00;
	ret |= (*(pt+2)<<16)&0x00ff0000;
	ret |= (*(pt+3)<<24)&0xff000000;
	return ret;
}

void ImageIO::short2byte(uint8_t *pt, uint16_t val) {
	*pt     = (uint8_t)val      &0x00ff;
	*(pt+1) = (uint8_t)((val>>8)&0x00ff);
}

void ImageIO::long2byte(uint8_t *pt, uint32_t val) {
	*pt     = (uint8_t)val       &0x000000ff;
	*(pt+1) = (uint8_t)((val>> 8)&0x000000ff);
	*(pt+2) = (uint8_t)((val>>16)&0x000000ff);
	*(pt+3) = (uint8_t)((val>>24)&0x000000ff);
}

unsigned char *ImageIO::Bmp2Rgb(const unsigned char *data, const unsigned long len)
{
	BMP_HEADER  bmp;
	char        *inpt, *outpt;
	long        pos, imgsize, x, y;
	unsigned char     *rgb;

	inpt  = (char *)data;
	outpt = (char*)&bmp;
	for (pos = 0; pos < sizeof(BMP_HEADER); outpt++, pos++) {
		*outpt = pgm_read_byte_near(inpt++);
	}

	img.Width  = swap16(bmp.Width);
	img.Height = swap16(bmp.Height);

	if (RGBs != NULL) free(RGBs);
	RGBs = (unsigned char *)malloc(img.Width * img.Height * 3);
	if (RGBs == NULL) return RGBs;

	imgsize = img.Width * img.Height;

	for (y = img.Height - 1; y>=0; y--) {
		for (x = 0; x<img.Width; x++) {
			rgb = RGBs + (y * img.Width + x) * 3;
			*(rgb+2) = pgm_read_byte_near(inpt++);
			*(rgb+1) = pgm_read_byte_near(inpt++);
			*rgb     = pgm_read_byte_near(inpt++);
		}
	}
	return RGBs;
}
