#ifndef __IMAGEIO_H
#define __IMAGEIO_H

#include <stdio.h>
#include <pgmspace.h>

class ImageIO
{
	private:

		typedef struct {
			// Header
			unsigned char Signature[2];   // 'BM'
			unsigned char FileSize[4];
			unsigned char reserved1[4];   // unused (=0)
			unsigned char DataOffset[4];
			// InfoHeader
			unsigned char Size[4];        // Size of InfoHeader =40 
			unsigned char Width[4];
			unsigned char Height[4];
			unsigned char Planes[2];      // always 1
			unsigned char BitPerPixel[2];
			unsigned char Compression[4];
			unsigned char ImageSize[4];
			unsigned char XpixelsPerM[4];
			unsigned char YpixelsPerM[4];
			unsigned char ColorsUsed[4];
			unsigned char ImportantColors[4];
		} BMP_HEADER;

		typedef struct {
			unsigned char  R;
			unsigned char  G;
			unsigned char  B;
		} BMP_RGB;

		typedef struct {
			long    Width;
			long    Height;
		} IMAGE_INFO;

		IMAGE_INFO img;
		unsigned char *RGBs;

		unsigned short swap16(unsigned char *pt);
		unsigned long  swap32(uint8_t *pt);
		void           short2byte(uint8_t *pt, uint16_t val);
		void           long2byte(uint8_t *pt, uint32_t val);

	public:
		ImageIO();
		~ImageIO();
		unsigned char *Bmp2Rgb(const unsigned char *data, const unsigned long len);
};

#endif /*__IMAGEIO_H*/
